;			------------------
;			 -- SLOADER III	--
;			  --------------
;
; ROUTINE LOADER >> OK	   CODE >> OK 

ORG	$7FC00
LOAD	$7FC00

;---------------------------------------------------------------
;---------------------------------------------------------------
;---  SELECTEUR LOADER III HAWK MEGA DEMO             -- 1990 --
;---------------------------------------------------------------
;---------------------------------------------------------------
ST:

EXECBASE=4
FINDTASK=-294
ADDPORT=-354
REMPORT=-360
OPENLIB=-408
CLOSELIB=-414
OPENDEV=-444
CLOSEDEV=-450
DOIO=-456
;----------------------------------------------------------------	
	EOR.B	#2,$BFE001		; ?
;----------------------------------------------------------------	
	CLR.L	D3
;----------------------------------------------------------------	
TEST:
	MOVE.L 	4,A6			;OUVRE GFX.LIBRARIE
	MOVE.W	#200,D0			; SIZE
	MOVE.L	#$C20000,A1		; LOCALISATION
	JSR 	-204(A6)

	TST.L 	D0
	BNE	E

	MOVE.W	#1,KEL
E:
;----------------------------------------------------------------	
	MOVE.L 	4,A6			;OUVRE GFX.LIBRARIE
	LEA 	GFXNAME,A1		;AVEC EXEC
	JSR 	-408(A6)
	MOVE.L 	D0,GFXBASE	
;----------------------------------------------------------------	
	ADDI.L 	#$32,D0			;PREPARE LE DMA
	MOVE.L 	D0,COPPTR		;ET ETEINT TOUTES
	MOVE.W 	#$4000,$DFF09A 		;LES IRQ
	MOVE.W 	#$85C0,$DFF096		;ALLUME TOUS LES REGISTRES DMA
;----------------------------------------------------------------	
	MOVE.L 	$6C,OLDIRQ		;INIT L'IRQ
	MOVE.L 	#NEWIRQ,$6C		
	MOVE.W 	#$C000,$DFF09A 
	MOVE.L 	COPPTR,A0		;ET METS LA NOUVEL
	MOVE.L 	(A0),OLDCOP		;COPPERLIST
	MOVE.L 	#COPPERLIST,(A0)	
;----------------------------------------------------------------	
MAIN:				
;	TST.W	BUG
;	BNE.S	FL3
	
	;TST.W	LOADIT
	;BNE.S	FL2

ZOO:	CMP.B	#255,$DFF006
	BNE.S	ZOO
	BRA.S	FL3

FL2:	;CMPI.B	#127,$DFF006
	;BNE.S	FL2

FL3:	;TST.W	LOADIT		
	;BNE.S	NO

	CMP.W	#0,KEL
	BNE	OL

	BRA.L	LOAD_TRACK		; CHARGE AND DECRUNCH
OL:
	BRA.L	LOAD_TRACK1		; CHARGE AND DECRUNCH

CONT:
;----------------------------------------------------------------	
;	FIN DU LOADER
;----------------------------------------------------------------	
	MOVE.W	#0,$DFF0A8
	MOVE.W	#0,$DFF0B8
	MOVE.W	#0,$DFF0C8
	MOVE.W	#0,$DFF0D8

END:	MOVE.W 	#$4000,$DFF09A		;ETEINT TOUTES LES IRQ
	MOVE.L 	OLDIRQ,$6C		
	MOVE.W 	#$C000,$DFF09A 		
	
	MOVE.L 	COPPTR,A0		;ETEINT LA COPPER
	MOVE.L 	OLDCOP,(A0)		;ET REMET L'INITIAL
	MOVE.W 	#$5,$DFF096		

;----------------------------------------------------------------	
	MOVE.L 	4,A6			;FERME GFX.LIBRARY
	MOVE.L 	GFXBASE,A1
	JSR 	-414(A6)
	CLR.L 	D0
JMP	$20000
;----------------------------------------------------------------	
;	APRES CHARGEMENT ET DECRUNCHING
;----------------------------------------------------------------	
NEWIRQ:					;INTERRUPTION NIVEAU 3
	MOVEM.L D0-D7/A0-A6,-(A7)	;REGISTRES AUTORISE
	MOVE 	SR,-(SP)		
	MOVE.W 	$DFF01E,D0		;VBL

	BTST	#5,D0
	BEQ.L 	ENDIRQ
SUITE:				
	TST.W	BUG
	BNE.S	FL4

	TST.W	LOADIT
	BEQ.S	FL1
	BRA.S	FL4
FL1:	CMPI.B	#00,$DFF006
	BNE.S	FL1
;----------------------------------------------------------------	
;LOADIT:
; 0 --> CHARGE
; 1 --> DECRUNCH

FL4:

ENDIRQ:	
	MOVE 	(SP)+,SR
	MOVEM.L	(SP)+,D0-D7/A0-A6
	DC.W 	$4EF9
;----------------------------------------------------------------	
OLDIRQ:		DC.L 	0
GO:		DC.W	0
KEL:		DC.W	0
;----------------------------------------------------------------	
LOAD_TRACK:
	MOVE.W	#$4EB9,$78EB8	
	MOVE.W	#$0006,$78EBA
	MOVE.W	#$8EB8,$78EBC

	MOVE.W	#0,BUG

	MOVE.L	EXECBASE,A6
	SUB.L 	A1,A1
	JSR 	FINDTASK(A6)
	MOVE.L 	D0,READREPLY+$10
	
	LEA 	READREPLY,A1
	JSR 	ADDPORT(A6)

	LEA 	DISKIO,A1
	MOVE.L 	#0,D0
	CLR.L 	D1
	LEA 	TRDDEVICE,A0
	JSR 	OPENDEV(A6)
	TST.L 	D0
	BNE	ERROR
	
	MOVE.L	#105*$200,D4	; TAILLE
	MOVE.L	#450*512,D5	; POSITION
OK_LOAD:
	LEA 	DISKIO,A1
	MOVE.L 	#READREPLY,14(A1)
	MOVE 	#2,28(A1)
	MOVE.L 	#$20000,$28(A1)
	MOVE.L 	D4,$24(A1)
	MOVE.L 	D5,$2C(A1)
	MOVE.L 	EXECBASE,A6
	JSR 	DOIO(A6)

	MOVE.L 	DISKIO+32,D6
	LEA 	DISKIO,A1
	MOVE 	#9,28(A1)
	MOVE.L 	#0,36(A1)
	JSR 	DOIO(A6)

	LEA 	READREPLY,A1
	JSR	REMPORT(A6)

	LEA 	DISKIO,A1
	JSR 	CLOSEDEV(A6)
NO_BOUCLE:
	MOVE.W	#1,LOADIT
ERROR:
	BRA	CONT
LOAD_TRACK1:
	MOVE.W	#$4EB9,$78EB8	
	MOVE.W	#$0006,$78EBA
	MOVE.W	#$8EB8,$78EBC


	MOVE.L	EXECBASE,A6
	SUB.L 	A1,A1
	JSR 	FINDTASK(A6)
	MOVE.L 	D0,READREPLY+$10
	
	LEA 	READREPLY,A1
	JSR 	ADDPORT(A6)

	LEA 	DISKIO,A1
	MOVE.L 	#0,D0
	CLR.L 	D1
	LEA 	TRDDEVICE,A0
	JSR 	OPENDEV(A6)
	TST.L 	D0
	BNE	ERROR1
	
	MOVE.L	#33*$200,D4	; TAILLE
	MOVE.L	#556*512,D5	; POSITION
OK_LOAD1:
	LEA 	DISKIO,A1
	MOVE.L 	#READREPLY,14(A1)
	MOVE 	#2,28(A1)
	MOVE.L 	#$20000,$28(A1)
	MOVE.L 	D4,$24(A1)
	MOVE.L 	D5,$2C(A1)
	MOVE.L 	EXECBASE,A6
	JSR 	DOIO(A6)

	MOVE.L 	DISKIO+32,D6
	LEA 	DISKIO,A1
	MOVE 	#9,28(A1)
	MOVE.L 	#0,36(A1)
	JSR 	DOIO(A6)

	LEA 	READREPLY,A1
	JSR	REMPORT(A6)

	LEA 	DISKIO,A1
	JSR 	CLOSEDEV(A6)
NO_BOUCLE1:
	MOVE.W	#1,LOADIT
	BRA	CONT
	MOVE.W	#0,LOADIT
ERROR1:
	RTS
;----------------------------------------------------------------
;	COPPER LISTE
;----------------------------------------------------------------
COPPERLIST:
	DC.L 	$01200000,$01220000,$01800000
	DC.L 	$00920038,$009400D0,$008E1F81,$00902EC1	
	DC.L 	$01000200,$01080000,$010A0000,$01020000
;----------------------------------------------------------------
	DC.L 	$009C8010,$FFFFFFFE
;----------------------------------------------------------------
;LABELS POUR COPPER
;----------------------------------------------------------------
GFXNAME:	DC.B	"graphics.library"
even
;----------------------------------------------------------------
GFXBASE:	DC.L	0
COPPTR:		DC.L	0
OLDCOP:		DC.L	0
;----------------------------------------------------------------
TRDDEVICE:	DC.B	'trackdisk.device',0
EVEN
;----------------------------------------------------------------
DISKIO:		BLK.L	20,0
READREPLY:	BLK.L	8,0
;----------------------------------------------------------------
RESULTAT:	DC.W	0
LOADIT:		DC.W	0
;----------------------------------------------------------------
WHICH_PART:	DC.W	0
BUG:		DC.W	1
;----------------------------------------------------------------
END_SOURCE:
;----------------------------------------------------------------
